<?php

namespace FiloBlu\Storelocator\Block\Plugin\Checkout;

class LayoutProcessor {

    public $_helper;
    protected $_customerSession;

    public function __construct(\FiloBlu\Storelocator\Helper\Data $helper, \Magento\Customer\Model\Session $customerSession) {
        $this->_helper = $helper;
        $this->_customerSession = $customerSession;
    }

    public function aroundProcess($subject, \Closure $proceed, $jsLayout) {

        $countAddresses = 0;

        if ($this->_customerSession->isLoggedIn()) {
          $countAddresses = count($this->_customerSession->getCustomer()->getAddresses());
        }

        if ($this->_helper->getConfig("carriers/pickup_in_store/active")) {

          $pickupinstoreForm = [
              'component' => 'FiloBlu_Storelocator/js/view/pickup-in-store',
              'sortOrder' => 0,
              'displayArea' => 'shippingAdditional',
              'config' => [
                  'template' => 'FiloBlu_Storelocator/pickup-in-store'
              ],
              'deps' => [
                  '0' => 'checkout.steps.shipping-step.shippingAddress'
              ]
          ];

          $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']['shippingAddress']['children']['pickupinstoreData'] = $pickupinstoreForm;

          $pickupinstoreChooser = [
              'component' => 'FiloBlu_Storelocator/js/view/pickup-in-store-chooser',
              'sortOrder' => ($countAddresses > 0 ? 0 : 100),
              'displayArea' => ($countAddresses > 0 ? 'address-list' : 'before-form'),
              'config' => [
                  'template' => 'FiloBlu_Storelocator/pickup-in-store-chooser'
              ],
              'deps' => [
                  '0' => 'checkout.steps.shipping-step.shippingAddress'
              ]
          ];

          $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']['shippingAddress']['children']['pickupinstoreChoser'] = $pickupinstoreChooser;

        }

        $customJsLayout = $proceed($jsLayout);

        return $customJsLayout;
    }
}
